from bpcms.models import Document, Folder
from django.conf import settings
import re

def content_menu(request):
    items = Document.objects.filter(folder__isnull=True, islive__exact=True)
    menu_items = []
    for item in items:
        if item.slug != 'index':
            menu_items.append(
                {
                    'title': item.title,
                    'url': item.get_basic_url(),
                }
            )
    folders = Folder.objects.filter(parent__isnull=True)
    for folder in folders:
        try:
            items = Document.objects.filter(folder__exact=folder, islive__exact=True, slug__exact='index')
            item = items[0]
            menu_items.append(
                {
                    'title': item.title,
                    'url': folder.get_basic_url(),
                }
            )
        except:
            pass

    menu_items.sort( \
        cmp=lambda x,y: cmp(x['title'].lower(), y['title'].lower()))

    return {
        'content_menu': menu_items,
    }

def content_submenu(request):
    # find where we are in the tree first
    folderpath = request.path
    folderpath = re.sub(u'^%s' %(settings.BPCMS_ROOT), '', folderpath)
    # right - that should be any prefix got rid of, now traverse the tree till
    # we've got something
    folder = None
    folderpath = folderpath.split('/')
    for part in folderpath:
        try:
            if folder:
                f = Folder.objects.get(parent__exact=folder, slug__exact=part)
            else:
                f = Folder.objects.get(parent__isnull=True, slug__exact=part)
            folder = f
        except:
            break

    # We have the folder (in theory)
    menu_items = []
    if folder:
        items = Document.objects.filter(folder__exact=folder, \
            islive__exact=True)
        for item in items:
            if item.slug != 'index':
                menu_items.append(
                    {
                        'title': item.title,
                        'url': item.get_basic_url(),
                    }
                )
        try:
            folders = Folder.objects.filter(parent__exact=folder)
        except:
            pass
        for folder in folders:
            try:
                items = Document.objects.filter(folder__exact=folder, \
                    islive__exact=True, slug__exact='index')
                for item in items:
                    menu_items.append(
                        {
                            'title': item.title,
                            'url': folder.get_basic_url(),
                        }
                    )
            except:
                pass

    menu_items.sort( \
        cmp=lambda x,y: cmp(x['title'].lower(), y['title'].lower()))

    return {
        'content_submenu': menu_items,
    }
